//  IDVI 1.0 source copyright 1996 Garth A. Dickie
//
//  This source is free for non-commercial use.  No warranty, etc.
//  Please acknowledge reuse by including the line:
//
//  "Based in part on IDVI 1.0 source copyright 1996 Garth A. Dickie"
//
//  in your documentation and source code.  For commercial use or
//  distribution, please contact the author.  Please also send
//  questions, comments, bug reports, or fixes.
//
//  Best Regards,
//  Garth A. Dickie
//  dickie@elastic.avid.com

package ibook.v10.util;

public class Lock {
    private boolean state;

    public final static boolean locked = false;
    public final static boolean unlocked = true;

    public Lock( ) {
        this( unlocked );
    }

    public Lock( boolean state ) {
        this.state = state;
    }

    final public synchronized void get( ) {
        while( state == locked )
            try {
                wait( );
            } catch( InterruptedException e ) {
            }

        state = locked;
    }

    final public synchronized void put( ) {
        state = unlocked;

        notify( );
    }
}
